using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_table_description")]
    public class SecurityTableDescriptionEntity : EntityBase<int>
    {

    public SecurityTableDescriptionEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
    [Column("description_id")]
    public int DescriptionId  { get; set; }
    [Column("table_name")]
    public string TableName  { get; set; }
    [Column("field_name")]
    public string FieldName  { get; set; }
    [Column("description")]
    public string? Description  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string DESCRIPTION_ID = "DescriptionId";
    public const string TABLE_NAME = "TableName";
    public const string FIELD_NAME = "FieldName";
    public const string DESCRIPTION = "Description";

    public const string DB_NAME_SECURITY_TABLE_DESCRIPTION = "security_table_description";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,description_id,table_name,field_name,description";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_DESCRIPTION_ID = "description_id";
    public const string DB_TABLE_NAME = "table_name";
    public const string DB_FIELD_NAME = "field_name";
    public const string DB_DESCRIPTION = "description";


    public static SecurityTableDescriptionEntity GetInstance()
    {
        return new SecurityTableDescriptionEntity();
    }

    public virtual void CopyFrom(SecurityTableDescriptionEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityTableDescriptionEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.DescriptionId =  source.DescriptionId;
        this.TableName =  source.TableName;
        this.FieldName =  source.FieldName;
        this.Description =  source.Description;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_TABLE_DESCRIPTION}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_TABLE_DESCRIPTION}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_DESCRIPTION_ID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_TABLE_DESCRIPTION}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityTableDescriptionEntity Clone()
    {
        SecurityTableDescriptionEntity result = new SecurityTableDescriptionEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
